config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.zfs.new

if [ -x /sbin/depmod ]; then
  chroot . /sbin/depmod -a >/dev/null 2>&1
fi
( cd etc/rc.d/init.d ; rm -rf zfs )
( cd etc/rc.d/init.d ; ln -sf ../rc.zfs zfs )
( cd etc/zfs/zed.d ; rm -rf scrub.finish-notify.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/scrub.finish-notify.sh scrub.finish-notify.sh )
( cd etc/zfs/zed.d ; rm -rf resilver.finish-notify.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/resilver.finish-notify.sh resilver.finish-notify.sh )
( cd etc/zfs/zed.d ; rm -rf io-spare.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/io-spare.sh io-spare.sh )
( cd etc/zfs/zed.d ; rm -rf io-notify.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/io-notify.sh io-notify.sh )
( cd etc/zfs/zed.d ; rm -rf data-notify.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/data-notify.sh data-notify.sh )
( cd etc/zfs/zed.d ; rm -rf checksum-spare.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/checksum-spare.sh checksum-spare.sh )
( cd etc/zfs/zed.d ; rm -rf checksum-notify.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/checksum-notify.sh checksum-notify.sh )
( cd etc/zfs/zed.d ; rm -rf all-syslog.sh )
( cd etc/zfs/zed.d ; ln -sf /usr/libexec/zfs/zed.d/all-syslog.sh all-syslog.sh )
( cd lib ; rm -rf libzfs.so )
( cd lib ; ln -sf libzfs.so.2.0.0 libzfs.so )
( cd lib ; rm -rf libzfs.so.2 )
( cd lib ; ln -sf libzfs.so.2.0.0 libzfs.so.2 )
( cd lib ; rm -rf libzfs_core.so )
( cd lib ; ln -sf libzfs_core.so.1.0.0 libzfs_core.so )
( cd lib ; rm -rf libzfs_core.so.1 )
( cd lib ; ln -sf libzfs_core.so.1.0.0 libzfs_core.so.1 )
( cd lib ; rm -rf libzpool.so )
( cd lib ; ln -sf libzpool.so.2.0.0 libzpool.so )
( cd lib ; rm -rf libzpool.so.2 )
( cd lib ; ln -sf libzpool.so.2.0.0 libzpool.so.2 )
( cd lib ; rm -rf libnvpair.so )
( cd lib ; ln -sf libnvpair.so.1.0.1 libnvpair.so )
( cd lib ; rm -rf libnvpair.so.1 )
( cd lib ; ln -sf libnvpair.so.1.0.1 libnvpair.so.1 )
( cd lib ; rm -rf libuutil.so )
( cd lib ; ln -sf libuutil.so.1.0.1 libuutil.so )
( cd lib ; rm -rf libuutil.so.1 )
( cd lib ; ln -sf libuutil.so.1.0.1 libuutil.so.1 )
